#include "dll.h"

// === Création et consultation ===
// crée la liste doublement chaînée
dll dll_create(){
    dll res;
    res.head = NULL;
    res.cur = NULL;
    return res;
}
// retourne la valeur à la position actuelle dans la liste
char* dll_value(dll list){
    if(list.cur == NULL){
        return NULL;
    }
    return list.cur->data;
}
// la liste est-elle vide?
bool dll_is_empty(dll list){
    return list.head==NULL;
}
// Est-ce que cur est le 1er élément?
bool dll_is_head(dll list){
    return list.head != NULL && list.head == list.cur;
}
// Est-ce que cur est le dernier élément?
bool dll_is_tail(dll list){
    return list.cur != NULL && list.cur->next == NULL;
}
// data est-elle dans la liste?
bool dll_is_present(dll list, char* data){
    return false;
}
// affiche la liste
void dll_print(dll list){
    if(!dll_is_empty(list)){
        list = dll_move_to_head(list);
        while(!dll_is_tail(list)){
            printf("%s\n", dll_value(list));
            list = dll_next(list);
        }
        printf("%s\n", dll_value(list));
    }
}

// === Manipulation ===
// déplace cur au début de la liste
dll dll_move_to_head(dll list){
    list.cur = list.head;
    return list;
}
// déplace cur à la position suivante dans la liste
dll dll_next(dll list){
    if(!dll_is_tail(list)){
        list.cur = list.cur->next;
    }
    return list;
}
// déplace cur à la position précédente dans la liste
dll dll_prev(dll list){
    if(!dll_is_head(list)){
        list.cur = list.cur->prev;
    }
    return list;
}

// === Insertion ===
// insertion de data dans l'élément après cur
dll dll_insert_after(dll list, char* data){
    // A IMPLEMENTER
    dll res;
    return res;
}
// insertion de data en tête de liste
dll dll_push(dll list, char* data){
    element *new = malloc(sizeof(element));
    new->prev = NULL;
    new->next = list.head;
    if(!dll_is_empty(list)){
        list.head->prev = new;
    }
    list.head = new;
    new->data = malloc(strlen(data)+1*sizeof(char));
    strcpy(new->data, data);
    return list;
}

// === Extraction === 
// extraction de la valeur se trouvant dans l'élément cur
// l'élément cur est libéré (mais pas la chaine de caractères)
char* dll_extract(dll *list){
    // A IMPLEMENTER
    return NULL;
}
// extrait la donnée en tête de liste
// l'élément en tête est libéré (mais pas la chaine de caractères)
char* dll_pop(dll *list){
    // A IMPLEMENTER
    return NULL;
}
// vide la liste (les chaines de caractères sont libérées)
void dll_destroy(dll *list){
    *list = dll_move_to_head(*list);
    element* cur = list->cur;
    while(cur !=NULL && cur->next != NULL){
        cur = cur->next;
        free(cur->prev->data);
        free(cur->prev);
    }
    free(cur->data);
    free(cur);
    list->head = NULL;
    list->cur = NULL;
}